define( [], function(  ) {
"use strict";


function formatPrompt()
{
};

formatPrompt.prototype.initialize = function( oControlHost, fnDoneInitializing )
{

  var o = oControlHost.configuration
    , prmptCtrl = oControlHost.page.getControlByName(o["promptName"])
    , styles = o["styles"]
    , stylesLen = styles.length
    , prmptElm = prmptCtrl.element
    , prmptID = prmptElm.id
    , prmptLst = prmptElm.getElementsByClassName('clsListView')[0]
    , prmptCmbo = prmptElm.getElementsByClassName('clsComboBox')[0]
    , prmptCmboId = prmptCmbo?prmptCmbo.id:''
    , prmptType
    , styleNode
    ;

    
/*
 * let's start by creating the style node for the new prompts. Each call to this script will append a value to this 
 * style node. I'll start with support for value prompts - lists, dropdown, radio, and checkboxes. 
 
 */
if(!document.getElementById('promptStyles')){
  var styleNode = document.createElement('style');
  styleNode.type = 'text/css';
  styleNode.id='promptStyles';
}
else {
  styleNode=document.getElementById('promptStyles');
}

  var addClass = function(style){
    if(!!(window.attachEvent && !window.opera)) {
          styleNode.styleSheet.cssText = style;
     } else {
          var styleText = document.createTextNode(style);
          styleNode.appendChild(styleText);
     }
    document.getElementsByTagName('head')[0].appendChild(styleNode)
  }
  
   
  /*IBM is a bit tricky. Dropdown prompts are actually found elsewhere on the page. This means we have to test if the 
   * prompt is a dropdown, and if it is we will apply the class TWICE. once for the main prompt and once for the hidden
   */
  
   for(var i=0;i<stylesLen;++i){
     //adding support for animations because SOMEONE made a silly comment about spinning text
     if(styles[i].keyframeName) {
       addClass('@keyframes '+styles[i].keyframeName+'{'+styles[i].style+'}');  
     }
     else {
       addClass('#'+prmptID+' .'+styles[i].className+'{'+styles[i].style+'}');  
       if(prmptCmbo) addClass('#'+prmptCmboId+'_ListViewDropDown'+' .'+styles[i].className+'{'+styles[i].style+'}');  
     }
   }

fnDoneInitializing();
	
};

return formatPrompt;
});